#ifndef DROPDOWNMENU_H
#define DROPDOWNMENU_H

#include <QObject>
#include <QMenu>
#include <QLabel>
#include <QHBoxLayout>
#include <QMouseEvent>

class MenuItem : public QWidget
{
    Q_OBJECT
public:
    MenuItem(QString week, int id, QWidget *parent = nullptr);
    QLabel       *m_pweekLabel;
    QLabel       *m_pselectedLabelIcon;
    QHBoxLayout  *m_pHWeekLayout;
    bool          m_mouseEnter = false;
    int           m_id = 0;
protected:
    void mouseReleaseEvent(QMouseEvent *event);
    void enterEvent(QEvent *e);
    void leaveEvent(QEvent *e);
    void paintEvent(QPaintEvent *event);
Q_SIGNALS:
    void showLabelIcon(int id);
    void hideLabelIcon(int id);
};

class DropDownMenu : public QMenu
{
    Q_OBJECT
public:
    DropDownMenu();
    void initWeekDateList();
    void initAllDateWidget();
    void initLabelStatus(QList<int> selectWeek);
    QStringList getWeekStringList();
    QString getChosenList(QList<int> selectList);
    QList<int> getWeekDateList(QString indexString);
protected:
    void mouseReleaseEvent(QMouseEvent *event);
    void paintEvent(QPaintEvent *event);
public Q_SLOTS:
    void handleShowLabelSlot(int id);
    void handleHideLabelSlot(int id);
private:
    QStringList m_pWeekDateList;
    QList<int> m_selectWeek;
};

#endif // DROPDOWNMENU_H
